#!/home/pi/.virtualenvs/cv/bin/python3
# -*- coding: utf-8 -*-
import os
import subprocess as sp
import time

g_path="/home/pi/robin/"
g_path_src=g_path + "src/" 
g_conf_path=g_path + "confs/" 

def get_usb_mac():
    p = sp.Popen("hciconfig | grep -B 1  BD",shell=True,stdout=sp.PIPE)
    data = p.communicate()
    std3 = data[0].decode(encoding = "utf-8")
    
    lsn = (std3.split("hci"))
    strr=""
    for x in lsn:
        if "UART" in x:
            y = x.split("BD Address:")
            strr=(y[1][1:18])
            
    return strr

def list_sinks(vol):
    p = sp.Popen("pactl list sinks",shell=True,stdout=sp.PIPE)
    data = p.communicate()
    std3 = data[0].decode(encoding = "utf-8")
    
    mp = std3.split("\n")
    lst = []
    for stt in mp:
        if "Аудиоприёмник №" in stt:
            nn = (stt[len("Аудиоприёмник №"):len(stt)]).strip()
            lst.append(int(nn))
            os.system("pactl set-sink-volume " + nn +" "+str(vol)+"%")
    return lst
def get_volume_sinks():
    p = sp.Popen("pactl list sinks|grep 'Громкость:'|awk '{print $5}'",shell=True,stdout=sp.PIPE)
    data = p.communicate()
    std = data[0].decode(encoding = "utf-8")
    print(p.returncode, std)
    
    
    std=std.strip("\n") 
    mpx = (std.split("\n"))
    
    print(mpx)
    
    mpy = []
    
    for x in mpx:
        y = (x.replace("%",""))
        print(y)
        if not y.isdigit():
            continue
        mpy.append(int((y)))
    if len(mpy) > 0:
        meany=sum(mpy)/len(mpy)
        mpy.append(int(meany))
    return mpy

pr_s = 0

sinks = get_volume_sinks()
vol =2
try:
    if not pr_s:
        f=  open(g_conf_path+"SetAudioVolume.txt","rt")
        vol=int(f.readline().strip())
        f.close()
    pr_s= (vol == sinks[len(sinks)-1])
except:
    pr_s=0
    vol = 50



mac2 = get_usb_mac()
print("mac2=",mac2)
pr = 0
t1 = 0

sts = sp.getoutput('pactl list sinks short| grep "usb"').split('\t')
if len(sts)>0:
	sts = sp.getoutput(f'pactl set-sink-mute {sts[0]} 1')

while not pr:
    
   
    

    macc = []
    std4 =(sp.getoutput('bt-device -l|grep -E "[0-F]{1,2}\:[0-F]{1,2}\:[0-F]{1,2}\:[0-F]{1,2}\:[0-F]{1,2}\:[0-F]{1,2}"')).split("\n")
    
    for spk in std4:
        if len(spk)<17:
            continue;
        macc.append(spk[-18:-1])
        
    if len(macc)<1:
        break
        
    
    print("diap mac",macc)
    
    std =(sp.getoutput('hcitool con'))
    print(std)
    
    pos = macc[0] in std
    if not pos:
        print("connect -a =" + mac2+" -c ="+macc[0])
        os.system(g_path_src +"connect_audio_device.sh "+macc[0]+" "+mac2)
    
    
    mac = ""
    pos3=0
    
    for kk in macc:
        ssc = sp.getoutput("pactl list sinks short")
        
        stp = kk.replace(":","_")

        if stp in ssc:
            
            mac = kk
            if "bluez_sink" in ssc: #a2dp_sink
                pr_ps = sp.getoutput("ps -ef|grep 'robin_embedded_client'|grep -v grep")
                if len(pr_ps):
                    print(pr_ps)
                    os.system(f'pactl set-card-profile bluez_card.{stp} headset_head_unit')
                else:
                    os.system(f'pactl set-card-profile bluez_card.{stp} a2dp_sink')
                    
                    
                    
                '''
                pr_ps = sp.getoutput("ps -ef|grep 'robin_embedded_client'|grep -v grep")
                if len(pr_ps):
                    for yyy in pps:
                        if os.path.exists('/proc/'+str(yyy)):
                '''
                print(stp)
                pos3 = 1
                break
                
    if mac=="":
        pr = 1
        print(pr)
        continue
    incl=0

    if pos and not pos3:
        os.system("bluetoothctl disconnect " +mac)
        print("disconnect -a " + mac2+" -d "+mac)
        pos = 0
        pr_s=0
        
        while not pos and incl< 10:
            std =(sp.getoutput('hcitool con'))
            print(std)
            pos = mac in std
            if not pos:
                print("connect -a =" + mac2+" -c ="+mac)
                os.system(g_path_src + "connect_audio_device.sh "+mac+" "+mac2)  
            
            incl = incl +1
            
    time.sleep(0.5)        
    if pos3:
        
        sts = sp.getoutput('pactl list sinks short| grep "usb"').split('\t')
        if len(sts)>0:
            sts = sp.getoutput(f'pactl set-sink-mute {sts[0]} 1')
            
        sts = sp.getoutput('pactl list sinks short| grep "bcm2835_audio.analog"').split('\t')
        
        if len(sts)>0:
            sts = sp.getoutput(f'pactl set-sink-mute {sts[0]} 0')
        
        pr = pos3
        print("pos3", pos3)

        sinks = get_volume_sinks()
        pr_s= (vol == sinks[len(sinks)-1])
        if pr_s:
            break

        if not pr_s:    
            try:               
                
                f=  open(g_conf_path + "SetAudioVolume.txt","rt")
                vol=int(f.readline().strip())
                f.close()
                
            except:
                pr_s=0
                vol = 50
##            
            list_sinks(vol)
