#!/home/pi/.virtualenvs/cv/bin/python3
# coding: utf-8
#from dotenv import load_dotenv
from requests import post
import json, base64, argparse, re, os, io, time, pydub 
#yaml, cv2
#from pydub.playback import play
import grpc, wave, queue
import threading as thr
#from picamera.array import PiRGBArray;from picamera import PiCamera;
from glob import glob
import numpy as np
import sys

import yandex.cloud.ai.tts.v3.tts_pb2 as tts_pb2
import yandex.cloud.ai.tts.v3.tts_service_pb2_grpc as tts_service_pb2_grpc
from multiprocessing import Process
import os;import subprocess as sp;


'''
load_dotenv()
API_KEY = os.getenv('API_KEY')
FOLDER_ID = os.getenv('FOLDER_ID')
VISION_URL = os.getenv('VISION_URL')
SYNTHESIZE_URL = os.getenv('SYNTHESIZE_URL')
'''
API_KEY='AQVN1BHQ6YJMpcDUTGpfJFqL0HCKScZzRe714wCS'
FOLDER_ID='b1g11m7mhrmq6mlquvqu'
VISION_URL='https://vision.api.cloud.yandex.net/vision/v1/batchAnalyze'
SYNTHESIZE_URL='https://tts.api.cloud.yandex.net/speech/v1/tts:synthesize'


#print(API_KEY, FOLDER_ID, VISION_URL, SYNTHESIZE_URL)
g_path = '/home/pi/robin/txt_rec/'
PLAY_LIST = queue.Queue()
PLAY_STOP = queue.Queue()
#pptq = queue.Queue()
#thr1q = queue.Queue()

STOP = False
fname = '/home/pi/voice_all/rus/Men/100/'

if len(sys.argv)>1 and len(sys.argv[1])>0:
    fname = sys.argv[1]


def ply(name):
    #flg = pptq.get()
    print('Play wait start')
    flg =True
    while flg:
        
        os.system(f'/home/pi/my_clnt {name}rec_processing.wav')
        print(f'/home/pi/my_clnt {name}rec_processing.wav')
        #say2(f'{name}rec_processing.wav')
        time.sleep(1)

def set_sink():
    std = sp.getoutput("pacmd list-sinks|grep 'name:'|awk '{print $2}'")
    lst = std.replace('<','').replace('>','').split('\n')
    if 'combined' in lst:
        os.system("pactl unload-module module-combine-sink")
        #exit(0)
    tst = 'pacmd load-module module-combine-sink sink_name=combined sink_properties=device.description=CombinedSink slaves='
    for i in lst:
        if 'combined' in i:
            continue
        if 'usb' in i:
            continue
        tst=tst + i +','
    tst = tst[:-1]
    os.system(tst)
    os.system("pacmd set-default-sink combined")
    vol = 100
    try: 
        with open("/home/pi/robin/confs/SetAudioVolume.txt", "rt") as ff:
            vol = int(ff.readline().strip())
    except:
        print('not volume data in def set_sink()')
        pass
    os.system(f"pactl set-sink-volume combined {vol}%")

def say(ffname):
    data = None    
    if os.path.exists(ffname):
        with open(ffname,"rb") as f:
            data = f.read()		
        sp.check_output(['aplay','-f','S16_LE', '-r','16000', '-c', '1','-q'], input=data)
        
def say2(ffname):
    data = None    
    if os.path.exists(ffname):
        with open(ffname,"rb") as f:
            data = f.read(22)
            data = f.read()		
        sp.check_output(['aplay','-f','S16_LE', '-r','16000', '-c', '1','-q'], input=data)


def make_photo():
    import RPi.GPIO as gp
    
    gp.setwarnings(0)
    gp.setmode(gp.BOARD)

    gp.setup(7, gp.OUT)
    gp.setup(11, gp.OUT)

    gp.output(7, 1)
    gp.output(11, 0)
    
    for fn in glob(f'{g_path}*.png'):
        os.remove(fn)
    
    os.system('echo "L_ON" > /dev/ttyS0')
    os.system(f'raspistill -w 1944 -h 2592 -rot 270 -o {g_path}image00_und.png --nopreview --exposure sports --timeout 1')
    os.system('/home/pi/my_clnt /home/pi/voice_all/rus/shot.wav')
    print('/home/pi/voice_all/rus/shot.wav')
    #say2('/home/pi/voice_all/rus/shot.wav')
    os.system('echo "L_OFF" > /dev/ttyS0')
    
    #gp.cleanup()

#ppt = Process(target=ply, args=(fname,))
#ppt.start()

def player_server(start, fname):
    
    stop = 0
    
    print('Playserver start')
    while start:
        
        #if not PLAY_LIST.empty():
        data = PLAY_LIST.get()
                            
        if stop==0:
            
            #'''
            while ppt.is_alive():
                os.system('killall -s9 my_clnt')
                ppt.terminate()
            #'''
            print(f'/home/pi/my_clnt {fname}rec_play.wav')
            #say2(f'{fname}rec_play.wav')
            os.system(f'/home/pi/my_clnt {fname}rec_play.wav')
            
            stop=1
            
        if data == 'end':
            PLAY_STOP.put(True)
            #out_file.export('/tmp/txt.wav', format='wav')
            #print('end')
            break
        print(f'Playserver playing...{data}')
        #'''
        out_file2 = pydub.AudioSegment.empty()
        
        out_file2 = out_file2.append(data, crossfade=0)
        out_file2.export('/tmp/tmp.wav', format='wav')
        os.system('/home/pi/my_clnt /tmp/tmp.wav')
        #'''
        '''
        audio_stream = io.BytesIO()
        data.export(audio_stream, format="wav")
                
        process = sp.Popen(["aplay", "-f", "S16_LE", "-r", "16000", '-c', '1','-q'], stdin=sp.PIPE, stderr=sp.PIPE, stdout=sp.PIPE)
        print(sp.getoutput("ps -ef|grep 'aplay'|grep -v grep"))
        xx, xxx = process.communicate(input=audio_stream.getvalue())
        print(xx.decode(), xxx.decode())
        
        #'''
    # else:
        # #print(f'not PLAY_LIST.empty()...{not PLAY_LIST.empty()}')
        # time.sleep(0.1)

def split_str(data_str):
    MAX_LENGTH = 249
    while len(data_str) > 0:
        if len(data_str) <= MAX_LENGTH:
            synthesize(API_KEY, data_str)
            break
        index = max(data_str.rfind(char, 0, MAX_LENGTH+1) for char in '.!?:,')
        if index == -1:
            synthesize(API_KEY, data_str[:MAX_LENGTH])
            data_str = data_str[MAX_LENGTH:]
        else:
            synthesize(API_KEY, data_str[:index+1])
            data_str = data_str[index+2:]

def pars_json(response_text):

    try:
        for i, k in enumerate(response_text['results'][0]['results'][0]['textDetection']['pages'][0]['blocks']):
            data_txt = ''
            for j in k['lines']:
                #data_txt = ''
                for l in j['words']:
                    data_txt += l['text'] + ' '
                #synthesize(API_KEY, data_txt)
                #os.system(f'echo "{data_txt}" >> /tmp/txt.txt')
            
            split_str(data_txt)
            os.system(f'/home/pi/my_clnt "{data_txt}"')
            os.system(f'echo "{data_txt}" >> /tmp/txt.txt')
            
        PLAY_LIST.put('end')
        
    except:
        data_txt = "Ничего не найдено"
        synthesize(API_KEY, data_txt)


def request_analyze(vision_url, folder_id, api_key, image_data):
    response = post(vision_url, headers={'Authorization': 'Api-Key ' + api_key}, json={
        'folderId': folder_id,
        'analyzeSpecs': [
            {
                'content': image_data,
                'features': [
                    {
                        'type': 'TEXT_DETECTION',
                        'textDetectionConfig': {'languageCodes': ['*']}
                    }
                ],
            }
        ]})
    with open(f'{g_path}response.json', 'w', encoding='utf-8') as file:
        json.dump(response.json(), file, indent=2, ensure_ascii=False)
    return response.json()


def analyze_image(image_path):
    
    thr1 = thr.Thread(target=player_server, daemon= True, args=(True,fname))
    thr1.start()
    
    with open(image_path, "rb") as f:
        image_data = base64.b64encode(f.read()).decode('utf-8')
    pars_json(request_analyze(VISION_URL, FOLDER_ID, API_KEY, image_data))


# Ограничение в 250 символов
out_file = pydub.AudioSegment.empty()

def synthesize(api_key, text) -> pydub.AudioSegment:
    
    voice = 'alena'
    if 'Men' in fname:
        voice = 'filipp'
    
    global speed   
    #print(speed)    
    request = tts_pb2.UtteranceSynthesisRequest(
        text=text,
        hints=[tts_pb2.Hints(voice=voice), tts_pb2.Hints(speed=speed)],
        output_audio_spec=tts_pb2.AudioFormatOptions(
            container_audio=tts_pb2.ContainerAudio(
                container_audio_type=tts_pb2.ContainerAudio.WAV
            )
        ),
        loudness_normalization_type=tts_pb2.UtteranceSynthesisRequest.LUFS
    )

    # Установить соединение с сервером.
    cred = grpc.ssl_channel_credentials()
    channel = grpc.secure_channel('tts.api.cloud.yandex.net:443', cred)
    stub = tts_service_pb2_grpc.SynthesizerStub(channel)

    # Отправить данные для синтеза.
    it = stub.UtteranceSynthesis(request, metadata=(
        ('authorization', f'Api-Key {api_key}'),
    ))

    # Собрать аудиозапись по чанкам.
    try:
        audio = io.BytesIO()
        
        for response in it:
            audio.write(response.audio_chunk.data)
                
        audio.seek(0)
        
        PLAY_LIST.put(pydub.AudioSegment.from_wav(audio).set_frame_rate(16000))
        
        #print(f'Playserver playing...{not PLAY_LIST.empty()}')
        
        global out_file
        
        out_file = out_file.append(pydub.AudioSegment.from_wav(audio).set_frame_rate(16000), crossfade=0)
        out_file.export('/tmp/txt.wav', format='wav')
             
    except grpc._channel._Rendezvous as err:
        print(f'Error code {err._state.code}, message: {err._state.details}')
        raise err


def main():
    '''
    with PLAY_LIST.mutex:
        PLAY_LIST.queue.clear()
    
    with PLAY_STOP.mutex:
        PLAY_STOP.queue.clear()
    
    with pptq.mutex:
        pptq.queue.clear()
        
    with thr1q.mutex:
        thr1q.queue.clear()
    
    global fname
    fname = ffname
    '''
    global speed
    try:
        speed = (fname.strip('/').split('/')[-1])#int(sp.getoutput('cat /home/pi/robin/confs/voice_speed.txt'))/100.0
        
    except:
        speed = '100'
        
    spd_r = ['50',	'60',	'70', '80',	'90',	'100',	'110',	'120',	'130',	'140',	'150']
    spd_y = [0.8,	0.9,	1.0,	1.1,	1.2,	1.3,	1.45,	1.6,	1.75,	1.9,	2.05]
    
    #global spdd 
    spdd = dict(zip(spd_r, spd_y))
    
    speed = spdd[speed]
    print(speed)
    
    #set_sink()
    os.system('rm -rf /tmp/txt.wav /tmp/txt.txt')
    
    #global ppt
    
    make_photo()
    
    global ppt
    ppt = Process(target=ply, args=(fname,))
    ppt.start()
    #pptq.put(True)
    
    #say2(f'{fname}rec_start.wav')
    
    #say2(f'{fname}rec_processing.wav')
    
    #say2(f'{fname}rec_play.wav')
    
    analyze_image(f'{g_path}image00_und.png')
    
    flg = None
    
    #PLAY_STOP.join()
    flg = PLAY_STOP.get()
    os.system(f'/home/pi/my_clnt {fname}rec_repit.wav')
    print(f'{fname}rec_repit.wav')
    #say2(f'{fname}rec_repit.wav')
    
    time.sleep(5)
    os.system(f'/home/pi/my_clnt {fname}rec_play.wav')
    print(f'{fname}rec_play.wav')
    #say2(f'{fname}rec_play.wav')
    os.system(f'/home/pi/my_clnt /tmp/txt.wav')
    print('/tmp/txt.wav')
    #say2('/tmp/txt.wav')


if __name__ == '__main__':
    main()
