#!/home/pi/.virtualenvs/cv/bin/python3
#-*- coding: UTF-8 -*-
#vim:fileencoding=utf-8
import RPi.GPIO as gp
import time
import os
import subprocess as sp
import sys

g_path = "/home/pi/robin/"

flag=False

if len(sys.argv)>1:
	##print("Not found packet name for reset!!!")
	flag = len(sys.argv[1])>0
    ##exit(0) 

if os.path.exists("/tmp/voice_all.zip"):
    #os.system("sudo apt-get -y install unzip")
    os.system("sudo unzip -o /tmp/voice_all.zip -d /home/pi/")
    
if os.path.exists("/tmp/cfg.zip"):
    #os.system("sudo apt-get -y install unzip")
    os.system("sudo unzip -o /tmp/cfg.zip -d /home/pi/")
    
if os.path.exists("/tmp/bills_detect.zip"):
    #os.system("sudo apt-get -y install unzip")
    os.system("unzip -o /tmp/bills_detect.zip -d /home/pi/robin")
    
if os.path.exists("/tmp/new_func.zip"):
    #os.system("sudo apt-get -y install unzip")
    os.system("unzip -o /tmp/new_func.zip -d /home/pi/robin")
    
if os.path.exists("/tmp/config.zip"):
    #os.system("sudo apt-get -y install unzip")
    os.system("sudo unzip -o /tmp/config.zip -d /boot")
    
if os.path.exists("/tmp/update.zip") and flag:##not os.path.exists(g_path+"utils/stm32_utils.py"):
    #os.system("sudo apt-get -y install unzip")
    os.system("unzip -o /tmp/update.zip -d "+g_path)


gp.setwarnings(0)
gp.setmode(gp.BOARD)

print("#5V_for RPi ON 1")
##input()
##exit(0)
#5V_for RPi setup
gp.setup(15, gp.OUT)
print("#5V_for RPi ON 2")
##input()
##exit(0)
#5V_for RPi ON
print("#5V_for RPi ON 3")
gp.output(15, True)
time.sleep(1)
##input()
##exit(0)
#boot_0 setup


gp.setup(12, gp.OUT)
#reset STM32 setup
gp.setup(13, gp.OUT)
print("#reset STM32 setup")
os.system("sudo apt -y install bluez")
# os.system("sudo apt-get -y install myspell-ru")
#os.system(". /home/pi/.virtualenvs/cv/bin/activate && pip install -U pip && pip install -r /home/pi/robin/txt_rec/requirements.txt")
#os.system(". /home/pi/.virtualenvs/cv/bin/activate && pip install -U pip && pip install /home/pi/tensorflow-2.4.0rc2-cp37-none-linux_armv7l.whl && pip install pyzbar")## && pip install -U pytesseract  && pip install -U scikit-image && pip install -U numpy && pip install -U pyenchant && pip install -U pymorphy2 && pip install -U smbus")
##&& pip install -U opencv-python && pip install -U opencv-contrib-python

os.system('echo "" > /home/pi/robin/txt_rec/pip.log')
pri = 0
prx = 0
while not pri and prx < 3:
    os.system(". /home/pi/.virtualenvs/cv/bin/activate && pip install -U pip && pip install -r /home/pi/robin/txt_rec/requirements.txt")
    
    os.system('. /home/pi/.virtualenvs/cv/bin/activate && pip freeze > /home/pi/robin/txt_rec/pip.log')
    with open('/home/pi/robin/txt_rec/pip.log', 'rt') as ff:
        aa = [xx.strip() for xx in ff]
    #print(aa)
    with open('/home/pi/robin/txt_rec/requirements.txt', 'rt') as ff:
        bb = [xx.strip() for xx in ff]
    #print(bb)    
    pri = 0
    for xx in bb:
        if '#' in xx:
            continue
        if not xx in aa:
            print (f"{xx} not install!!!")
            break
        pri+=1
    pri = pri > 13
    prx+=1
    print(pri)
#exit(0)
stt = sp.getoutput("ls /dev/ttyUSB*")
if "Нет такого файла" in stt:
    print("Нет подходящего для прошивки устройства")
    time.sleep(5)
    gp.output(15, False)
    time.sleep(0.1)
    gp.output(13, False)
    sp.getoutput("sudo reboot")
    exit(0)



binfs = list(filter(lambda x: x.endswith(".binary"),os.listdir("/home/pi/robin/")))
if len(binfs)<1:
    print("Файлов прошивки МК не найдено...для применения обновлений перезагрузка...")
    time.sleep(5)
    gp.output(15, False)
    time.sleep(0.1)
    gp.output(13, False)
    sp.getoutput("sudo reboot")
    exit(0)
print(binfs)

##input()

for fname in binfs:
    if not os.path.exists("/home/pi/robin/"+fname):
        print("Файл прошивки МК не найден")
        continue

    print('wait_12')
    time.sleep(2)
    #boot_0 'HIGH'
    gp.output(12, True)
    #reset STM32 'LOW'
    gp.output(13, False)
    print('reset')
    time.sleep(0.3)

    #reset STM32 'HIGH'
    gp.output(13, True)
##    gp.output(12, False)
    #5V_for RPi OFF
##    gp.output(15, False)

##    time.sleep(1)
    print('loading')
    asd = os.system(f'stm32flash -w "{g_path}' +fname+ '" -v -g 0x0 /dev/ttyUSB0')
    print('done')
    time.sleep(1)
    os.system(f'rm -f "{g_path}'+fname+'"')
    print("Прошивка MK завершена")
    time.sleep(7)
    gp.output(15, False)
    print('check')
    gp.output(13, False)
    gp.cleanup()
    sp.getoutput("sudo reboot")
    
